/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Convert AVATAR number into ANSI sequence                               *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "prog.h"

void Std_Num_To_Ansi(int avatar,char *ansi)
{
  int fore,
      back;

  static char scratch[13];

  avatar &= 0x7f;     /* Strip off high bit! */

  strcpy(ansi,"\x1b[");

  back=avatar/16;
  avatar -= back*16;
  fore=avatar;

  if (fore > 7)
  {
    fore -= 8;
    strcat(ansi,"0;1;");
  }
  else strcat(ansi,"0;");

  _Std_Num_To_Ansi(&fore);

  itoa(fore,scratch,10);

  if (back==0)
  {
    strcat(ansi,"3");
    strcat(ansi,scratch);
  }
  else
  {
    strcat(ansi,"3");
    strcat(ansi,scratch);
    strcat(ansi,";4");

    _Std_Num_To_Ansi(&back);

    itoa(back,scratch,10);
    strcat(ansi,scratch);
  }

  strcat(ansi,"m");
}




void _Std_Num_To_Ansi(int *avatar)
{
  switch(*avatar)
  {
    case 0:
      *avatar=0;
      break;

    case 1:
      *avatar=4;
      break;

    case 2:
      *avatar=2;
      break;

    case 3:
      *avatar=6;
      break;

    case 4:
      *avatar=1;
      break;

    case 5:
      *avatar=5;
      break;

    case 6:
      *avatar=3;
      break;

    case 7:
      *avatar=7;
      break;
  }
}



/*                             Foregrounds
Ŀ
 BLACK  BLUE   GREEN  CYAN   RED   MAGENTAYELLOW  WHITE  BACK-  
low hi low hi low hi low hi low hi low hi low hi low hi  GROUND 
Ĵ
  0   8  1   9  2  10  3  11  4  12  5  13  6  14  7  15BLACK   
 16  24 17  25 18  26 19  27 20  28 21  29 22  30 23  31BLUE    
 32  40 33  41 34  42 35  43 36  44 37  45 38  46 39  47GREEN   
 48  56 49  57 50  58 51  59 52  60 53  61 54  62 55  63CYAN    
 64  72 65  73 66  74 67  75 68  76 69  77 70  78 71  79RED     
 80  88 81  89 82  90 83  91 84  92 85  93 86  94 87  95MAGENTA 
 96 104 97 105 98 106 99 107100 108101 109102 110103 111YELLOW  
112 120113 121114 122115 123116 124117 125118 126119 127WHITE   

*/


